Program PAT_NRG;

{ Programm zum patchen eines CDROM-Images (*.NRG, *.C2D) mit }
{ der vom ACTIVY 300 erwarteten Signatur                     }

{ Written for Borland Pascal 7.0 Real Mode!! }

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,100000,655360}

{$I-} { wichtig !}

Const

 { This pattern is to be searced, $40 is then wildcard }

 SECION_ENTRY : Array[1..16] Of Word = (
 $0001, { 0 }
 $0000, { 1 }
 $4040, { 2 }  { $40 = Wildcard, must not match! }
 $4040, { 3 }
 $4040, { 4 }
 $4040, { 5 }
 $4040, { 6 }
 $4040, { 7 }
 $4040, { 8 }
 $4040, { 9 }
 $4040, {10 }
 $4040, {11 }
 $4040, {12 }
 $4040, {13 }
 $4040, {14 } { checksum }
 $aa55);{15 }

 
 { The new checksum is calculated by adding all words like this:
   var l:longint; l:=0; for i:=1 to 16 do l:=l+swap(SECION_ENTRY_ACTIVY[i]);
   the result (l) must be zero!!. swap() means exchange hibyte with lowbyte }

 { This is the new signatur, including checksum }

 SECION_ENTRY_ACTIVY : Array[1..16] Of Word = (
 $0001, { 0 }
 $0000, { 1 }
 $4341, { 2 }
 $4954, { 3 }
 $5956, { 4 }
 $0000, { 5 }
 $0000, { 6 }
 $0000, { 7 }
 $0000, { 8 }
 $0000, { 9 }
 $0000, {10 }
 $0000, {11 }
 $0000, {12 }
 $0000, {13 }
 $6fBF, {14 } { checksum }
 $aa55);{15 }


Type

 B_TYP = Array[1..50000] Of Byte;
 B_PTR = ^B_TYP;

Var

 F          : File;
 BUFF       : B_PTR;
 RREAD      : Word;
 NUM        : Word;
 FND        : Boolean;
 ABS_FPOS   : LongInt;
 S_BYTES    : Word;
 FNAME      : String;
 IOR        : Integer;
 OFFSET     : LongInt;

{**********************************************************************}
Function File_Exist( F_NAME:String ):Boolean;

Var
 EX_FILE:File;
 FMODE_SAVE:Byte;

Begin
 Assign(EX_FILE,F_NAME);
 FMODE_SAVE:=SYSTEM.FILEMODE;
 SYSTEM.FILEMODE:=0;
 Reset(EX_FILE);
 If IOResult=0
  Then
   Begin
    Close(EX_FILE);
    File_Exist:=True;
   End
  Else
   File_Exist:=False;
 SYSTEM.FILEMODE:=FMODE_SAVE;
End;

{****************************************************************************}
Procedure SEARCH_WITH_WILDCARDS( Var STRG;
                                     S_LEN:WORD;
                                 Var NUM:Word;
                                 Var FND:Boolean;
                                 Var VST;
                                     S_END:Word);

Begin
 ASM
        MOV     AX,0                    { FALSE }
        LES     DI,[FND]                { Adr of FOUND }
        MOV     ES:[DI],AL              { Set FALSE }

        PUSH    DS                      { Save DS }

        LES     DI,[NUM]                { Adr of NUM }
        MOV     BX,ES:[DI]              { Position in buffer }

        CLD                             { Clear Direction }

        LES     DI,VST                  { Adr of buffer }
        ADD     DI,BX                   { Add Offset }
        MOV     AX,DI                   { Save it }

        LDS     SI,[STRG]               { Adr of Search String }
        MOV     DX,SI                   { Save it }

        MOV     CX,[S_LEN]              { Length of Search String }
        JCXZ    @SW6                    { Jmp if search string length = 0 }
        SUB     [S_END],CX              { decrement buffer size by length of search string }
        JC      @SW6                    { jmp if length of search string > buffer size }

@SW1:   CMP     BX,[S_END]              { passt string noch voll rein ? }
        JA      @SW6                    { nein -> exit, not found }

        MOV     DI,AX                   { Get Adr of buffer Position }
        MOV     SI,DX                   { Get Adr of Search String }
        MOV     CX,[S_LEN]              { Length of Search String }
        PUSH    AX

@SW0:   MOV     AL,[SI]                 { Get Character from Search String }
        CMP     AL,"@"                  { Is it a wildcard ? }
        JZ      @SW4                    { Jmp if so }
        CMP     AL,ES:[DI]              { Match with buffer ? }
        JNZ     @SW5                    { Jmp if not }
@SW4:   Inc     SI                      { Next Character from Search String }
        Inc     DI                      { Next Character from buffer }
        Dec     CX                      { Dec counter }
        JNZ     @SW0                    { Jmp if not Zero }
        JE      @SW2                    { Jmp if matched }

@SW5:   POP     AX
        Inc     AX                      { Next buffer Position }
        Inc     BX                      { Next buffer Field }
        JMP     @SW1                    { Check Next Position }

@SW6:   MOV     BX,0                    { Not found }
        JMP     @SW3                    { Done ! }

@SW2:   POP     AX
        MOV     AX,1                    { TRUE }
        LES     DI,[FND]                { Adr of FOUND }
        MOV     ES:[DI],AL              { Set TRUE }

@SW3:   LES     DI,[NUM]                { Adr of NUM }
        MOV     ES:[DI],BX              { Set Position }

        POP     DS                      { Restore DS }
 End;
End;

{****************************************************************************}
Procedure HELP;

Const

 MAX_MSG = 11;

 MSG:Array[1..MAX_MSG] Of String[80]=
 ('',
  'Dieses Programm patched ein CDROM-Image (*.NRG, *.C2D) einer bootbaren CD',
  'nach "El Torito" Format (http://www.phoenix.com/PlatSS/PDFs/specs-cdrom.pdf)',
  'mit der vom ACTIVY 300 erwarteten Signatur (mit NERO und WinONCD getestet).',
  'Nach dem Patch kann das Image gebrannt werden.',
  '',
  'Aufruf Syntax fr Modifikation:',
  '',
  'PAT_NRG fname.ext',
  '',
  'fnam.ext: Dateiname des CDROM Images, Achtung KEINE langen Dateinamen mglich!'
 );

Var I:Integer;

Begin
 For I:=1 To MAX_MSG Do WriteLn(MSG[I]);
 Halt(1);
End;

{****************************************************************************}
Procedure SEARCH;

Var I : Word;

Begin

 WriteLn;
 Write('Searching ... ');

 While Not Eof(F) Do
  Begin

   Seek(F,ABS_FPOS); IOR:=IOResult;

   BlockRead( F, BUFF^, SizeOf(BUFF^), RREAD); IOR:=IOResult;

   { now search the WHOLE Buffer }

   NUM:=0;
   SEARCH_WITH_WILDCARDS( SECION_ENTRY, S_BYTES, NUM, FND, BUFF^, Sizeof(BUFF^));

   If FND
    Then
     Begin
      OFFSET:=ABS_FPOS+NUM;
      Write('Signature found at position ',OFFSET,': >');
      For I:=Num+4 To Num+27 Do If BUFF^[I]<>0 Then Write(Char(BUFF^[I]));
      WriteLn('<');
      BREAK;
     End;

   { make new fileposition, to ensure no problems with page boundaries }
   { e.g. search string starts at end of page -1 }

   ABS_FPOS := ABS_FPOS + RREAD - S_BYTES + 1;

  End;
End;

{****************************************************************************}
Procedure PATCH;

Begin
 ABS_FPOS:=OFFSET;
 WriteLn('New Values patched!');
 Seek(F,ABS_FPOS); IOR:=IOResult;
 BlockWrite( F, SECION_ENTRY_ACTIVY, S_BYTES, RREAD); IOR:=IOResult;
End;
{****************************************************************************}

Begin

 Assign(OutPut,'');
 ReWrite(OutPut);

 BUFF := Nil; New( BUFF );

 If ParamCount<>1 Then HELP;

 FNAME:=ParamStr(1);

 If Not File_Exist(FNAME)
  Then
   Begin
    WriteLn(#7'File ',FNAME,' not found!, program aborted.');
    Halt(1);
   End;

 Assign(F,FNAME);
 Reset(F,1); IOR:=IOResult;

 FillChar( BUFF^, SizeOf(BUFF^), 0);

 S_BYTES  := SizeOf(SECION_ENTRY);
 ABS_FPOS := 0;
 OFFSET   := 0;

 SEARCH;

 If (OFFSET<>0)
  Then
   Begin
    patch;
   End
  Else
   Begin
    WriteLn;
    WriteLn(#7'Patch position not found !');
    Halt(1);
   End;

 WriteLn;

 Close(F); IOR:=IOResult;

End.

